#include <windows.h>
#include <GL/gl.h>
#include "r_nmt.h"

#define NMTEXTURE_ITSELF

#include "nmtexture.h"

/*
*   ȉ̃CfbNXŃeNX`Zbg܂
*   HAIKEI_TEX_INDEX    0
*   CARDURA_TEX_INDEX   1
*   CARD_TEX_INDEX      2-
*/
void setTexture(int tex_index){
  glBindTexture(GL_TEXTURE_2D , texName[tex_index]);
}

/*
*   eNX`f[^t@Cǂ݂܂
*    f[^\͈ȉ̒ʂ
*    FRQrbgl(rbOGfBA)
*    cFRQrbgl(rbOGfBA)
*    qfalFeWrbg
*    ȍ~AqfalJԂ
*/
int readTexture(int tex_index, char *filename){
  free_nmt(nmt[tex_index]);

  nmt[tex_index] = read_nmt(filename);

  if(nmt[tex_index] == NULL){
    return 0;
  }

  glBindTexture(GL_TEXTURE_2D, texName[tex_index]);

  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

  glTexImage2D (GL_TEXTURE_2D
    ,0                            /* ~bv}bvgȂ̂0 */
    ,3                            /* RGBȂ̂3 */
    ,nmt[tex_index]->width        /*  */
    ,nmt[tex_index]->height       /*  */
    ,0                            /* E̕ */
    ,GL_RGB                       /* RGB` */
    ,GL_UNSIGNED_BYTE             /* oCgf[^ */
    ,nmt[tex_index]->data_rgb);   /* C[Wւ̃|C^ */
  /* SɌJԂGL_REPAET ł؂ GL_CLAMP */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  /* TɌJԂGL_REPAET ł؂ GL_CLAMP */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  /* eNX`̊g GL_NEAREST or GL_LINEAR ( or Y) */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  /* eNX`̏k GL_NEAREST or GL_LINEAR ( or Y) */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  /* ̖ʂ̐F𖳎 */
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);

  return 1;
}

int initTexture(){
  int result = 1;

  glGenTextures(MAX_TEX, texName);

  result &= readTexture(HAIKEI_TEX_INDEX, HAIKEI_TEX1);
  result &= readTexture(CARDURA_TEX_INDEX, CARDURA_TEX1);
  result &= readTexture(CARD_TEX_INDEX + 0, CARD01_TEX);
  result &= readTexture(CARD_TEX_INDEX + 1, CARD02_TEX);
  result &= readTexture(CARD_TEX_INDEX + 2, CARD03_TEX);
  result &= readTexture(CARD_TEX_INDEX + 3, CARD04_TEX);
  result &= readTexture(CARD_TEX_INDEX + 4, CARD05_TEX);
  result &= readTexture(CARD_TEX_INDEX + 5, CARD06_TEX);
  result &= readTexture(CARD_TEX_INDEX + 6, CARD07_TEX);
  result &= readTexture(CARD_TEX_INDEX + 7, CARD08_TEX);
  result &= readTexture(CARD_TEX_INDEX + 8, CARD09_TEX);
  result &= readTexture(CARD_TEX_INDEX + 9, CARD10_TEX);
  result &= readTexture(CARD_TEX_INDEX + 10, CARD11_TEX);
  result &= readTexture(CARD_TEX_INDEX + 11, CARD12_TEX);
  result &= readTexture(CARD_TEX_INDEX + 12, CARD13_TEX);
  result &= readTexture(CARD_TEX_INDEX + 13, CARD14_TEX);
  result &= readTexture(CARD_TEX_INDEX + 14, CARD15_TEX);
  result &= readTexture(CARD_TEX_INDEX + 15, CARD16_TEX);
  result &= readTexture(CARD_TEX_INDEX + 16, CARD17_TEX);
  result &= readTexture(CARD_TEX_INDEX + 17, CARD18_TEX);
  result &= readTexture(CARD_TEX_INDEX + 18, CARD19_TEX);
  result &= readTexture(CARD_TEX_INDEX + 19, CARD20_TEX);
  result &= readTexture(CARD_TEX_INDEX + 20, CARD21_TEX);
  result &= readTexture(CARD_TEX_INDEX + 21, CARD22_TEX);
  result &= readTexture(CARD_TEX_INDEX + 22, CARD23_TEX);
  result &= readTexture(CARD_TEX_INDEX + 23, CARD24_TEX);
  result &= readTexture(CARD_TEX_INDEX + 24, CARD25_TEX);
  result &= readTexture(CARD_TEX_INDEX + 25, CARD26_TEX);
  result &= readTexture(CARD_TEX_INDEX + 26, CARD27_TEX);
  result &= readTexture(CARD_TEX_INDEX + 27, CARD28_TEX);
  result &= readTexture(CARD_TEX_INDEX + 28, CARD29_TEX);
  result &= readTexture(CARD_TEX_INDEX + 29, CARD30_TEX);
  result &= readTexture(CARD_TEX_INDEX + 30, CARD31_TEX);
  result &= readTexture(CARD_TEX_INDEX + 31, CARD32_TEX);

  return result;
}

void deinitTexture(){
  int i;

  for(i = 0; i < MAX_TEX; i++){
    free_nmt(nmt[i]);
  }
}
