#ifndef __R_NM3__
#define __R_NM3__

typedef struct nm3dst{
  int vertex;
  int face;
  GLfloat *data_vertex;
  int *data_face;
  GLfloat *data_normal;
}nm3dst;

#ifdef R_NM3_ITSELF
#define R_NM3_EXT

static float nm3_swapF(float f);
static int nm3_swapW(int w);

#else
#define R_NM3_EXT extern
#endif

R_NM3_EXT nm3dst *read_nm3(char *file_name);
R_NM3_EXT void free_nm3(nm3dst *n3);

#endif
