#ifndef __SS_ATARI__
#define __SS_ATARI__

#ifdef SS_ATARI_ITSELF
#define SS_ATARI_EXT

static int v_flag = 0;
static int screenwidth = 0;
static int screenheight = 0;
static GLfloat v[64][16];
static GLint v2[64][4][2];

static int cross_point(int ay, int bx1, int by1, int bx2, int by2);
static int in_triangle(int x, int y, int ax, int ay, int bx, int by, int cx, int cy);
static void from3Dto2D(float x, float y, float z, int *px, int *py);
static void set_atari(int num);
static void setV(int num, GLfloat *pv);
static int atari_card(int x, int y, int num);


#else
#define SS_ATARI_EXT extern
#endif

SS_ATARI_EXT int atariCard(int x, int y, int num);
SS_ATARI_EXT GLfloat *getV(int num);
SS_ATARI_EXT void change_v(int sw, int sh, int row, int col);

#endif
