#include <stdlib.h>
#include <time.h>

#define SS_STATE_ITSELF

#include "ss_state.h"

/*
*   state_table[x] ɂׂ STATE_CLOSE 
*/
int createState(int num){
  int i;

  if(num < 1 || num > 64){
    return 0;
  }

  for(i = 0; i < num; i++){
    state_table[i] = STATE_CLOSE;
  }

  state_num = num;

  return 1;
}

/*
*   J[hSĕԂ
*/
int initState(int num){
  int result;

  result = createState(num);

  if(!result){
    return 0;
  }

  return 1;
}

/*
*   index ̃J[hɏԂ
*/
int setState(int index, int state){

  if(index < 0 || index >= state_num){
    return 0;
  }

  state_table[index] = state;

  return 1;
}

/*
*   index ̃J[h̏Ԃ擾
*/
int getState(int index, int *state){

  if(index < 0 || index >= state_num){
    return 0;
  }

  *state = state_table[index];

  return 1;
}

/*
*   Ԃ^Ƃ̏Ԃ̃J[h邩Ԃ
*/
int countState(int state){
  int i;
  int count = 0;

  for(i = 0; i < state_num; i++){
    if(state - state_table[i] == 0){
      count++;
    }
  }

  return count;
}

/*
*   Ԃw肵āA_őI񂾃J[h index 擾
*   jSTATE_CLOSE ̃J[h index ԍǂł̂ŗ~A
*/
int getRandomIndex(int state, int *index){
  int i;
  int c = 0;
  int s;
  int r;
  int count;

  srand((unsigned)time(NULL));

  count = countState(state);

  if(count <= 0){
    return 0;
  }

  r = rand() % count;

  for(i = 0; i < state_num; i++){
    getState(i, &s);

    if(s == state){
      if(c == r){
        *index = i;

        return 1;
      }

      c++;
    }
  }

  return 0;
}

/*
*   J[h̍ő喇 0 
*/
void deinitState(void){
  state_num = 0;
}
