#include <stdlib.h>
#include <time.h>

#define SS_TABLE_ITSELF

#include "ss_table.h"

/*
*   num ̃J[h_ɕׂ
*   table[0]  table[num-1]  1  num ̐_ɓ
*/
int createTable(int num){
  int i, c;
  int r;

  if(num < 1 || num > 64){
    return 0;
  }
  
  table_num = num;

  srand((unsigned)time(NULL));

  for(i = 0, c = 1; i < num; i++, c++){
    r = rand() % c;

    table[i] = 0;

    if(table[r] != 0){
      table[i] = table[r];
      table[r] = c;
    }
    else{
      table[i] = c;
    }
  }

  return 1;
}

/*
*   J[h̐
*/
int initTable(int num){
  int result;

  result = createTable(num);

  if(!result){
    return 0;
  }

  return 1;
}

/*
*   index Ԃ̐ num ̃AhXɓ
*/
int getTableNumber(int index, int *num){
  if(index < 0 || index >= table_num){
    return 0;
  }

  *num = table[index];

  return 1;
}

/*
*   J[h̍ő喇Ԃ
*/
int getTableSize(void){
  return table_num;
}

/*
*  J[h̍ő喇 0 ɂ
*/
void deinitTable(void){
  table_num = 0;
}
