#ifndef __NMTEXTURE__
#define __NMTEXTURE__

#define MAX_HAIKEI_TEX     1
#define MAX_CARDURA_TEX    1
#define MAX_CARD_TEX       32
#define MAX_TEX            MAX_HAIKEI_TEX+MAX_CARDURA_TEX+MAX_CARD_TEX

#define HAIKEI_TEX_INDEX    0
#define CARDURA_TEX_INDEX   1
#define CARD_TEX_INDEX      2

#define HAIKEI_TEX1   "nmt\\haikei.nmt"
#define CARDURA_TEX1  "nmt\\cardura.nmt"
#define CARD01_TEX    "nmt\\card01.nmt"
#define CARD02_TEX    "nmt\\card02.nmt"
#define CARD03_TEX    "nmt\\card03.nmt"
#define CARD04_TEX    "nmt\\card04.nmt"
#define CARD05_TEX    "nmt\\card05.nmt"
#define CARD06_TEX    "nmt\\card06.nmt"
#define CARD07_TEX    "nmt\\card07.nmt"
#define CARD08_TEX    "nmt\\card08.nmt"
#define CARD09_TEX    "nmt\\card09.nmt"
#define CARD10_TEX    "nmt\\card10.nmt"
#define CARD11_TEX    "nmt\\card11.nmt"
#define CARD12_TEX    "nmt\\card12.nmt"
#define CARD13_TEX    "nmt\\card13.nmt"
#define CARD14_TEX    "nmt\\card14.nmt"
#define CARD15_TEX    "nmt\\card15.nmt"
#define CARD16_TEX    "nmt\\card16.nmt"
#define CARD17_TEX    "nmt\\card17.nmt"
#define CARD18_TEX    "nmt\\card18.nmt"
#define CARD19_TEX    "nmt\\card19.nmt"
#define CARD20_TEX    "nmt\\card20.nmt"
#define CARD21_TEX    "nmt\\card21.nmt"
#define CARD22_TEX    "nmt\\card22.nmt"
#define CARD23_TEX    "nmt\\card23.nmt"
#define CARD24_TEX    "nmt\\card24.nmt"
#define CARD25_TEX    "nmt\\card25.nmt"
#define CARD26_TEX    "nmt\\card26.nmt"
#define CARD27_TEX    "nmt\\card27.nmt"
#define CARD28_TEX    "nmt\\card28.nmt"
#define CARD29_TEX    "nmt\\card29.nmt"
#define CARD30_TEX    "nmt\\card30.nmt"
#define CARD31_TEX    "nmt\\card31.nmt"
#define CARD32_TEX    "nmt\\card32.nmt"

#ifdef NMTEXTURE_ITSELF
#define NMTEXTURE_EXT

static GLuint texName[MAX_TEX];
static nmtxst *nmt[MAX_TEX];

static int readTexture(int tex_index, char *filename);

#else
#define NMTEXTURE_EXT extern
#endif

NMTEXTURE_EXT int initTexture();
NMTEXTURE_EXT void setTexture(int tex_index);
NMTEXTURE_EXT void deinitTexture();

#endif
