#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define SS_COM_ITSELF

#include "ss_com.h"

/*
*   JJ[h͋Lɒǉ
*/
void addComMemory(int num, int point){
  memory_index--;

  if(memory_index < 0){
    memory_index = MAX_MEMORY - 1;
  }

  memory[memory_index].num = num;
  memory[memory_index].point = point;
}

/*
*   Lobt@ɃZbg
*/
int setComMemory(int past, card_memory cm){
  int index;

  if(past < 0 || past >= MAX_MEMORY){
    return 0;
  }

  index = memory_index + past;

  index %= MAX_MEMORY;

  memory[index].num = cm.num;
  memory[index].point = cm.point;

  return 1;
}


/*
*   obt@L𓾂
*/
int getComMemory(int past, card_memory *mem){
  int index;

  if(past < 0 || past >= MAX_MEMORY){
    return 0;
  }

  index = memory_index + past;

  index %= MAX_MEMORY;

  mem->num = memory[index].num;
  mem->point = memory[index].point;

  return 1;
}

/*
*   ďɖJ[h͋LɂƋ̂ŏ
*/
int deleteComMemory(int num){
  int i;

  card_memory cm;

  for(i = 0; i < MAX_MEMORY; i++){
    getComMemory(i, &cm);

    if(cm.num - num == 0){
      cm.num = 0;
      cm.point = 0;

      setComMemory(i, cm);
    }
  }

  return 1;
}

/*
*   LɂċL̃CfbNXʒu
*/
void initCom(int level){
  int i;

  memory_index = MAX_MEMORY;

  for(i = 0; i < MAX_MEMORY; i++){
    memory[i].num = 0;
    memory[i].point = 0;
  }

  switch(level){
    case 0:
      memory_rate = com0;
      break;
    case 1:
      memory_rate = com1;
      break;
    case 2:
      memory_rate = com2;
      break;
    case 3:
      memory_rate = com3;
      break;
    case 4:
      memory_rate = com4;
      break;
    case 5:
      memory_rate = com5;
      break;
    case 6:
      memory_rate = com6;
      break;
    case 7:
      memory_rate = com7;
      break;
    default:
      memory_rate = com7;
      break;
  }
}

/*
*   a / b ̊m 1 Ԃ łȂ 0 Ԃ
*/
int getComRandHit(int a, int b){
  int h;

  srand((unsigned)time(NULL));

  h = rand() % b;

  if(h - a > 0){
    return 0;
  }

  return 1;
}

/*
*   L̒vQT
*/
int getComFirstThink(int *index1, int *index2){
  int i, t;
  card_memory cm1, cm2;

  for(t = 0; t < MAX_MEMORY; t++){
    for(i = t + 1; i < MAX_MEMORY - t - 1; i++){
      getComMemory(t, &cm1);
      getComMemory(i, &cm2);

      if(cm1.num == 0 || cm2.num == 0){
        continue;
      }

      if(cm1.num - cm2.num == 0 && cm1.point - cm2.point != 0){
        int hit;
        hit = getComRandHit(memory_rate[t] * memory_rate[i], 10000);

        if(hit == 1){
          *index1 = cm2.point;
          *index2 = cm1.point;

          return 1;
        }
      }
    }
  }

  return 0;
}

/*
*   PƋL̒vPT
*/
int getComSecondThink(int num, int point, int *index2){
  int i;
  card_memory cm;

  for(i = 0; i < MAX_MEMORY; i++){
    getComMemory(i, &cm);

    if(cm.num == 0){
      continue;
    }

    if(cm.num - num == 0 && cm.point - point != 0){
      int hit;
      hit = getComRandHit(memory_rate[i], 100);

      if(hit == 1){
        *index2 = cm.point;

        return 1;
      }
    }
  }

  return 0;
}
