#include <windows.h>
#include <GL/gl.h>
#include "nmTexture.h"

#define SS_HAIKEI_ITSELF

#include "ss_haikei.h"

void loopHaikei(){
  fx += 0.001f;
  fy += 0.001f;
}

void paintHaikei(){
  glMatrixMode(GL_TEXTURE);
	
  glPushMatrix();

  glTranslated(fx, fy, 0.0);

  glMatrixMode(GL_MODELVIEW);
	
  glLoadIdentity();

  glRotated(45.0, 0.0, 0.0, 1.0);
	
  glEnable(GL_TEXTURE_2D);

  setTexture(HAIKEI_TEX_INDEX);
	
  glBegin(GL_QUADS);
	
  glTexCoord2f(0.0, 10.0);
  glVertex3f(-2.8f, 2.0f, -2.0f);
  glTexCoord2f(0.0, 0.0);
  glVertex3f(-2.8f, -2.0f, -2.0f);
  glTexCoord2f(14.0, 0.0);
  glVertex3f(2.8f, -2.0f, -2.0f);
  glTexCoord2f(14.0, 10.0);
  glVertex3f(2.8f, 2.0f, -2.0f);
		
  glEnd();
	
  glDisable(GL_TEXTURE_2D);
	
  glMatrixMode(GL_TEXTURE);
	
  glPopMatrix();
	
  glMatrixMode(GL_MODELVIEW);
}
