#ifndef __SS_SOUND__
#define __SS_SOUND__

#define CHANNELS 2
#define SOUND_BITS 16
#define SAMPLE_RATE 44100

#define SOUND_BUFFER_SIZE 176400

#define MUTEX_STRING "mutex_ss_sound"

#ifdef SS_SOUND_ITSELF
#define SS_SOUND_EXT

typedef struct{
  int done;
  BOOL thread_end;
}DATA, *PDATA;

static DATA data1;
static HANDLE hThread1;
static DWORD thId1;

static FILE *fp;
static long filesize;

static HWAVEOUT hWOut;
static WAVEHDR wh[2];
static WAVEFORMATEX wf;
static char buffer[2][SOUND_BUFFER_SIZE];

static HANDLE hMutex;

static int swapW(int w);
static void get_buf(char *buf, int size);

static void SoundThread(void *);
static void CALLBACK waveProc(HWAVEOUT, UINT, DWORD, DWORD, DWORD);

#else
#define SS_SOUND_EXT extern
#endif

SS_SOUND_EXT int initSound(char *filename);
SS_SOUND_EXT void playSound();
SS_SOUND_EXT void deinitSound();

#endif
