#ifndef __SS_STATE__
#define __SS_STATE__

#ifdef SS_STATE_ITSELF
#define SS_STATE_EXT

static int state_table[64];
static int state_num = 0;
static int ss_width = 0;
static int ss_height = 0;

static int createState(int);

#else
#define SS_STATE_EXT extern
#endif

#define STATE_CLOSE 0
#define STATE_OPEN  1
#define STATE_SPACE 2

SS_STATE_EXT int initState(int);
SS_STATE_EXT int setState(int, int);
SS_STATE_EXT int getState(int, int *);
SS_STATE_EXT int getRandomIndex(int, int*);
SS_STATE_EXT int countState(int);
SS_STATE_EXT void deinitState(void);

#endif
